package escape;

import java.awt.*;

public class CreditsMode implements IMode {

  private String[] credits = {
      "CONGRATULATIONS!",
      "",
      "",
      "YOU WASTED",
      "",
      "",
      "ESCAPE THE MEN'S ROOM",
      "WAS CREATED BY MICHAEL BIRKEN.",
      "",
      "",
      "",
      "",
      "\u00A9 2011 MEATFIGHTER.COM"
  };
  private int[] xOffsets = new int[credits.length];
  private int[] yOffsets = new int[credits.length];

  private boolean cursorVisible;
  private int line;
  private int blinkDelay = 1;
  private StringBuilder sb = new StringBuilder(" ");
  private int blinks;
  private int typeDelay = 1;
  private int typeIndex;

  @Override
  public void update() {
    if (--blinkDelay == 0) {
      blinks++;
      blinkDelay = 30;
      cursorVisible = !cursorVisible;
      sb.setCharAt(sb.length() - 1, cursorVisible ? '_' : ' ');
    }
    if (blinks > 6) {
      if (typeIndex < credits[line].length()) {
        if (--typeDelay == 0) {
          typeDelay = 1 + GameMode.random.nextInt(31);
          sb.setLength(sb.length() - 1);
          sb.append(credits[line].charAt(typeIndex++));
          sb.append(cursorVisible ? '_' : ' ');
        }
      } else if (line < credits.length - 1) {
        sb.setLength(1);
        sb.setCharAt(0, cursorVisible ? '_' : ' ');
        typeIndex = 0;
        line++;        
      } else {
        sb.setCharAt(sb.length() - 1, cursorVisible ? '_' : ' ');
      }
    }
  }

  @Override
  public void render(Graphics2D g) {
    g.setColor(Color.WHITE);
    g.fillRect(0, 0, 800, 600);

    for(int i = line - 1; i >= 0; i--) {
      Images.drawString(g, credits[i], xOffsets[i], yOffsets[i]);
    }
    Images.drawString(g, sb, xOffsets[line], yOffsets[line]);
  }

  @Override
  public void enter() {
    long time = System.currentTimeMillis() - GameState.startTime;
    long minutes = time / 60000;
    long hours = minutes / 60;
    minutes %= 60;

    String timeString = "";

    if (hours == 1) {
      timeString += "1 HOUR";
    } else if (hours > 1) {
      timeString += hours + " HOURS";
    }
    if (minutes > 0) {
      if (hours != 0) {
        timeString += " AND ";
      }
      if (minutes == 1) {
        timeString += "1 MINUTE.";
      } else {
        timeString += minutes + " MINUTES.";
      }
    } else {
      timeString += ".";
    }

    credits[4] = timeString;

    for(int i = 0; i < credits.length; i++) {
      xOffsets[i] = (800 - credits[i].length() * 25) >> 1;
    }

    int y = (600 - (credits.length << 5)) >> 1;
    for(int i = 0; i < credits.length; i++) {
      yOffsets[i] = y;
      y += 32;
    }
  }
}
