package escape;

import java.awt.Color;
import java.awt.Graphics2D;

public class DrainMagnetMode extends GameMode {

  public static final int MAGNET_X = 281;
  public static final int MAGNET_Y = -109;

  public static final int LACE_X = 356;
  public static final int LACE_Y = -562;

  public static final int PICK_X = 415;
  public static final int PICK_Y = 65;

  private int y;
  private int vy = 2;

  @Override
  public void modify() {
    y += vy;
    if (y >= 642) {
      vy = -vy;
    }
    if (y < -475) {
      addToInventory(Images.picks[2]);
      main.setMode(main.drainMode);
    }
  }

  @Override
  public void draw(Graphics2D g) {
    g.setClip(0, 80, 800, 520);

    g.setColor(Color.BLACK);
    g.fillRect(0, 400, 800, 200);
    g.drawImage(Images.drains[1], 0, 80, null);

    if (vy < 0) {
      g.drawImage(Images.picks[1], PICK_X, PICK_Y + y, null);
    }

    g.drawImage(Images.magnets[3], MAGNET_X, MAGNET_Y + y, null);
    g.drawImage(Images.shoeLaces[3], LACE_X, LACE_Y + y, null);
    g.drawImage(Images.drains[0], 0, 417, null);

    g.setClip(null);
  }

  @Override
  public boolean isInventoryAccessible() {
    return false;
  }
}
