package escape;

import java.awt.*;
import java.util.*;

public class LockMode extends GameMode {

  public int[] offsets = new int[6];
  public int[][] sequences = new int[6][5];

  public LockMode() {

    do {
      for(int i = 0; i < 6; i++) {
        offsets[i] = 4;
        ArrayList<Integer> list = new ArrayList<Integer>();
        for(int j = 0; j < 5; j++) {
          list.add(j);
        }
        for(int j = 0; j < 5; j++) {
          sequences[i][j] = list.remove(random.nextInt(list.size()));
        }
      }
    } while(isSolved());    
  }

  private boolean isSolved() {
    for(int i = 0; i < 6; i++) {
      if (GameState.lockCombination[i] != sequences[i][4 - offsets[i]]) {
        return false;
      }
    }
    return true;
  }

  private void addClickRegions() {
    clickRegions.clear();
    for(int i = 0; i < 6; i++) {
      int x = 140 + i * 94;
      if (offsets[i] > 0) {
        clickRegions.add(new Region(x, 113, 43, (offsets[i] + 1) * 43, i));
      }
      if (offsets[i] < 4) {
        clickRegions.add(new Region(x,
            371 + 43 * offsets[i], 43, (5 - offsets[i]) * 43, 6 + i));
      }
    }
    clickRegions.add(new Region(
        750, 80, 50, 520, 12, Images.arrowCursors[Images.RIGHT]));
  }

  @Override
  public void modify() {
  }

  @Override
  public void draw(Graphics2D g) {
    g.drawImage(Images.lock, 0, 80, null);

    // 140, 113
    // 94 apart
    for(int i = 0; i < 6; i++) {
      int x = 140 + i * 94;
      g.drawImage(Images.springs[offsets[i]], x, 113, null);
      g.drawImage(Images.springs[4 - offsets[i]], x, 
          371 + 43 * offsets[i], null);
      for(int j = 0; j < 5; j++) {
        g.drawImage(Images.blocks[sequences[i][j]], x + (j & 1),
            156 + (offsets[i] + j) * 43, null);
      }
    }
  }

  @Override
  public boolean isInventoryAccessible() {
    return false;
  }

  @Override
  public void regionClicked(Region clickRegion) {
    if (clickRegion.id < 6) {
      offsets[clickRegion.id]--;
    } else if (clickRegion.id < 12) {
      offsets[clickRegion.id - 6]++;
    } else {
      if (isSolved()) {
        GameState.doorUnlocked = true;
      } else {
        addToInventory(Images.picks[2]);
      }
      main.setMode(main.doorMode);
      main.showMouseCursor();
    }
    addClickRegions();
  }

  @Override
  public void enter() {
    super.enter();
    setMouseCursor(new MouseCursor(Images.picks[0], 2, 39));
    addClickRegions();
  }
}
